#include "clfe.h"
#include "iclfe.h"
#include "bccfe.h"
#include "libfe.h"
#include "tlibfe.h"

namespace win32fe {

  void CreateCL(  tool *&Tool) {Tool = new cl;}
  void CreateICL( tool *&Tool) {Tool = new icl;}
  void CreateIFL( tool *&Tool) {Tool = new ifl;}
  void CreateDF(  tool *&Tool) {Tool = new df;}
  void CreateBCC( tool *&Tool) {Tool = new bcc;}
  void CreateLIB( tool *&Tool) {Tool = new lib;}
  void CreateTLIB(tool *&Tool) {Tool = new tlib;}

  int tool::Create(tool *&Tool,std::string argv) {
    std::string KnownTools = "cl.icl.ifl.df.f90.bcc32.lib.tlib";
    std::map<std::string,void (*)(win32fe::tool*&)> CreateTool;
    CreateTool["cl"] = win32fe::CreateCL;
    CreateTool["icl"] = win32fe::CreateICL;
    CreateTool["ifl"] = win32fe::CreateIFL;
    CreateTool["df"] = win32fe::CreateDF;
    CreateTool["f90"] = win32fe::CreateDF;
    CreateTool["bcc32"] = win32fe::CreateBCC;
    CreateTool["lib"] = win32fe::CreateLIB;
    CreateTool["tlib"] = win32fe::CreateTLIB;

    if (KnownTools.find(argv)==std::string::npos) {
      Tool = new(tool);
    } else {
      CreateTool[argv](Tool);
    }
    (Tool->arg).push_front(argv);
    return(0);
  }

};

